/*
getmm.c  Version 0.3.0 Mega Millions Odds
Copyright (C) 2002-2010   dondalah721@yahoo.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License as
published by the Free Software Foundation; either version 2 of
the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

/*
Usage:
    	int select;
    	int megaball;
    	double odds;
    	double getmm(int select, int megaball);
    	odds = getmm(select,megaball);
*/

#include <stdio.h>
#include <stdlib.h>

#define FIFTYTWO 52

double getmm(select,megaball)
int select;
int megaball;
   {
   double odds;
   double max52;
   double topwin,toplose;
   double top;
   double bottom;
   double dbl52,dbl47,dbl51;
   double combo(int n, int r);

   top = combo(5,5);

   if (select < 0 || select > 5)
      {
      fprintf(stderr,"getmm: invalid select %d\n",
         select);
      exit(1);
      } /* invalid select */
   if (megaball < 0 || megaball > 1)
      {
      fprintf(stderr,"getmm: invalid mega ball %d\n",
         megaball);
      exit(1);
      } /* invalid megaball */
   if (select >= 0 && select <= 2)
      {
      if (megaball != 1)
         {
         fprintf(stderr,"getmm: invalid mega ball %d "
            "when select is %d\n",
            megaball, select);
         exit(1);
         } /* invalid megaball */
      } /* select = 2,1,0 */

   max52 = FIFTYTWO;
   dbl52 = (double) max52;
   dbl47 = dbl52 - 5.0;
   dbl51 = dbl52 - 1.0;

   if (select == 5 && megaball == 1)
      {
      top = combo(5,5);
      bottom = combo(max52,5) * dbl52;
      odds = bottom / top;
      return(odds);
      } /* 5 1 */

   else if (select == 5 && megaball == 0)
      {
      topwin  = combo(5,select);
      toplose = dbl51;
      top = topwin * toplose;
      bottom = combo(max52,5) * dbl52;
      odds = bottom / top;
      return(odds);
      } /* 5 0 */

   else if (select == 4 && megaball == 1)
      {
      topwin  = combo(5,select);
      toplose = combo(47,5 - select);
      top = topwin * toplose;
      bottom = combo(max52,5) * dbl52;
      odds = bottom / top;
      return(odds);
      } /* 4 1 */

   else if (select == 4 && megaball == 0)
      {
      topwin  = combo(5,select);
      toplose = combo(47,5 - select) * dbl51;
      top = topwin * toplose;
      bottom = combo(max52,5) * dbl52;
      odds = bottom / top;
      return(odds);
      } /* 4 0 */

   else if (select == 3 && megaball == 1)
      {
      topwin  = combo(5,select);
      toplose = combo(47,5 - select);
      top = topwin * toplose;
      bottom = combo(max52,5) * dbl52;
      odds = bottom / top;
      return(odds);
      } /* 3 1 */

   else if (select == 3 && megaball == 0)
      {
      topwin  = combo(5,select);
      toplose = combo(47,5 - select) * dbl51;
      top = topwin * toplose;
      bottom = combo(max52,5) * dbl52;
      odds = bottom / top;
      return(odds);
      } /* 3 0 */

   else if (select == 2 && megaball == 1)
      {
      topwin  = combo(5,select);
      toplose = combo(47,5 - select);
      top = topwin * toplose;
      bottom = combo(max52,5) * dbl52;
      odds = bottom / top;
      return(odds);
      } /* 2 1 */

   else if (select == 1 && megaball == 1)
      {
      topwin  = combo(5,select);
      toplose = combo(47,5 - select);
      top = topwin * toplose;
      bottom = combo(max52,5) * dbl52;
      odds = bottom / top;
      return(odds);
      } /* 1 1 */

   else if (select == 0 && megaball == 1)
      {
      topwin  = combo(5,select);
      toplose = combo(47,5 - select);
      top = topwin * toplose;
      bottom = combo(max52,5) * dbl52;
      odds = bottom / top;
      return(odds);
      } /* 0 1 */
   fprintf(stderr,"getmm: edit failed for "
      "mega ball %d when select is %d\n",
      megaball, select);
   exit(1);
   } /* getmm */
